<!DOCTYPE html>
<html>
  <head>
    <link rel="shortcut icon" type="image/png" href="https://raw.githubusercontent.com/DiegoFeijo13/jepo-rpg-images/master/favicon.png" />
    <link rel="stylesheet" type="text/css" href="src/scripts/semantic/semantic.min.css"/>
    <link rel="stylesheet" href="src/scripts/style.css">
    
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="src/scripts/semantic/semantic.min.js"></script>   
    
    <script src="https://cdn.jsdelivr.net/npm/vue@2.6.14"></script>
    
    <title>Gerenciador de Encontros</title>
  </head>

  <body class="bgimg">
    <div class="ui inverted vertical masthead center aligned segment">
      <div class="ui text container">
        <div class="ui inverted vertical masthead center aligned segment">
          <h1>Gerenciador de Encontros para D&D.</h1>          
        </div>
      </div>
    </div>

    <div id="app" class="ui container" style="margin:16px;">
      <!--Menu-->
      <div class="ui three item stackable tabs menu">
        <a class="item" data-tab="pdjs">Jogadores</a>
        <a class="item active" data-tab="monstros">Monstros</a>
        <a class="item" data-tab="encontro">Encontro</a>
      </div>
      <!--Players-->
      <div class="ui tab" data-tab="pdjs">
        <div class="ui segment">
          <div class="ui tiny form">
            <h4 class="ui dividing header">Adicionar PDJ</h4>
            <div class="fields">
              <div class="seven wide field">
                <input type="text" placeholder="Nome" v-model="char_name" />
              </div>
              <div class="three wide field">
                <input
                  type="number"
                  placeholder="Percepção"
                  v-model="char_passive_perception"
                />
              </div>
              <div class="three wide field">
                <input
                  type="number"
                  placeholder="Investigação"
                  v-model="char_passive_investigation"
                />
              </div>
              <div class="three wide field">
                <input
                  type="number"
                  placeholder="Intuição"
                  v-model="char_passive_insight"
                />
              </div>
            </div>
          </div>
          <div class="ui bottom attached button" @click="addPlayer">
            Adicionar
          </div>
        </div>

        <div class="ui raised cards">
          <div class="card" v-for="p in players" :key="p.name">
            <div class="content">
              <div class="header">{{ p.name }}</div>
              <div class="description">
                <div class="ui three tiny statistics">
                  <div class="statistic">
                    <div class="value">{{ p.perception }}</div>
                    <div class="label">PER</div>
                  </div>
                  <div class="statistic">
                    <div class="value">{{ p.investigation }}</div>
                    <div class="label">INV</div>
                  </div>
                  <div class="statistic">
                    <div class="value">{{ p.insight }}</div>
                    <div class="label">INT</div>
                  </div>
                </div>
                <br/>
                <div class="ui left icon fluid input">                                 
                  
                  <input
                    type="number"
                    placeholder="Iniciativa"
                    v-model="p.initiative"
                  />
                  <i class="flag checkered icon"></i>
                </div>                
              </div>
            </div>
            <div
              class="ui bottom attached button"
              @click="removePlayer(players.indexOf(p))"
            >
              Remover
            </div>
          </div>
        </div>
      </div>
      <!--Monstros-->
      <div class="ui active tab" data-tab="monstros">
        <div class="ui segment">
          <div class="ui tiny form">
            <h4 class="ui dividing header">Dados do Monstro</h4>
            <div class="fields">
              <div class="six wide field">
                <label>Nome</label>
                <input type="text" placeholder="Nome" v-model="mons_name" />
              </div>
              <div class="two wide field">
                <label>Nr Dados</label>
                <input type="number" placeholder="Dados" v-model="dice_num" />
              </div>
              <div class="two wide field">
                <label>Dado de Vida</label>
                <select v-model="hit_die">
                  <option value="2">d2</option>
                  <option value="4">d4</option>
                  <option value="6">d6</option>
                  <option value="8">d8</option>
                  <option value="10">d10</option>
                  <option value="12">d12</option>
                  <option value="20">d20</option>
                </select>
              </div>
              <div class="two wide field">
                <label>PV Base</label>
                <input type="number" placeholder="PV Base" v-model="base_hp" />
              </div>
              <div class="two wide field">
                <label>Mod Destreza</label>
                <input type="number" placeholder="Mod Destreza" v-model="dex" />
              </div>
              <div class="two wide field">
                <label>Nr Monstros</label>
                <input
                  type="number"
                  placeholder="Nr Monstros"
                  v-model="mon_num"
                />
              </div>
            </div>
            <div
              class="ui button bottom attached"
              id="gerar-btn"
              @click="generate"
            >
              Gerar Encontro
            </div>
          </div>
        </div>
        <div class="ui placeholder segment" v-show="monsters.length === 0">
          <div class="ui icon header">
            <i class="paw icon"></i>
            Parece que os aventureiros estão bem tranquilos... <br />
            Que tal uma batalha épica pra esquentar as coisas? <br />
            Preencha os campos acima e gere um encontro.
          </div>
        </div>

        <table
          class="ui compact table"
          v-show="monsters.length > 0"
          style="margin-bottom: 48px;"
        >
          <thead>
            <th style="text-align: center;">Iniciativa</th>
            <th>Monstro</th>
            <th style="text-align: center;">PV</th>
            <th style="text-align: right;">
              <button
                class="ui icon button"
                @click="monsters.splice(0,monsters.length)"
              >
                <i class="undo icon"></i>
              </button>
            </th>
          </thead>
          <tbody>
            <tr
              v-for="m in monsterByInitiative"
              :key="m.id"
              v-bind:class="m.damage >= m.hp? dead : ''"
            >
              <td style="text-align: center;">{{ m.initiative }}</td>
              <td>{{ m.name }}</td>
              <td style="text-align: center;">{{ m.hp }}</td>

              <td style="text-align: right;">
                <button
                  class="ui icon button"
                  @click="monsters.splice(monsters.indexOf(m),1)"
                >
                  <i class="times circle icon"></i>
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <!--Turno-->
      <div class="ui tab" data-tab="encontro">

        <table
          class="ui compact table"
          v-show="monsters.length > 0"
          style="margin-bottom: 48px;"
        >
          <thead>
            <th style="text-align: center;">Iniciativa</th>
            <th>Monstro</th>
            <th style="text-align: center;">PV / Dano</th>
            <th style="text-align: center;">Status</th>
            <th style="text-align: center;">Causar Dano</th>
            <th style="text-align: center;">Recuperar Vida</th>
            <th style="text-align: right;">
              <button
                class="ui icon button"
                @click="monsters.splice(0,monsters.length)"
              >
                <i class="undo icon"></i>
              </button>
            </th>
          </thead>
          <tbody>
            <tr
              v-for="m in turnOrder"
              :key="m.id"
              v-bind:class="m.damage >= m.hp? dead : ''"
            >
              <td style="text-align: center;">{{ m.initiative }}</td>
              <td>{{ m.name }}</td>
              <td style="text-align: center;"><div v-show="m.type === 'monster'">{{ m.hp }} / {{ m.damage }}</div></td>
              <td style="text-align: center;">
                <div v-show="m.type === 'monster'">
                <button
                  class="ui grey mini circular button"
                  @click="m.status1 = !m.status1"
                  v-bind:class="{ red: m.status1 }"
                ></button>
                <button
                  class="ui grey mini circular button"
                  @click="m.status2 = !m.status2"
                  v-bind:class="{ blue: m.status2 }"
                ></button>
                <button
                  class="ui grey mini circular button"
                  @click="m.status3 = !m.status3"
                  v-bind:class="{ green: m.status3 }"
                ></button>
                <button
                  class="ui grey mini circular button"
                  @click="m.status4 = !m.status4"
                  v-bind:class="{ purple: m.status4 }"
                ></button>
              </div>
              </td>
              <td style="text-align: center;">
                  <div v-show="m.type === 'monster'">
                <button
                  class="ui red mini circular button"
                  @click="m.damage+=1"
                >
                  1
                </button>
                <button
                  class="ui red mini circular button"
                  @click="m.damage+=5"
                >
                  5
                </button>
                <button
                  class="ui red mini circular button"
                  @click="m.damage+=10"
                >
                  10
                </button>
                </div>                
              </td>
              <td style="text-align: center;">
                  <div v-show="m.type === 'monster'">
                <button
                  class="ui blue mini circular button"
                  @click="m.damage-=1"
                >
                  1
                </button>
                <button
                  class="ui blue mini circular button"
                  @click="m.damage-=5"
                >
                  5
                </button>
                <button
                  class="ui blue mini circular button"
                  @click="m.damage-=10"
                >
                  10
                </button>
                </div>
              </td>

              <td style="text-align: right;">
                  <div v-show="m.type === 'monster'">
                <button
                  class="ui icon button"
                  @click="monsters.splice(monsters.indexOf(m),1)"
                >
                  <i class="times circle icon"></i>
                </button>
                </div>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
    <div class="ui inverted vertical footer segment">
      <div class="ui container" style="text-align: right;">
        <p>
          Desenvolvido por <a href="http://www.jeporpg.com.br">JepoRpg</a>.
          Copyright © 2019 Comitiva Escarlate
        </p>
      </div>
    </div>

    <script src="src/scripts/App.js"></script>
    <script>
      $("ui.dropdown").dropdown();
      $(".menu .item").tab();
    </script>
  </body>
</html>
